/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000 NETSYS GmbH. All Rights Reserved.
//
// MODULE: 2os2_lnx.h 
//
// DESCRIPTION:
//              Declaration of constants and functions for Linux 
//              kernel driver execution (VM execution)
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __2OS2_LNX
#define __2OS2_LNX

#include "page_man.h"

//ioctls
#define IOCTL_CODE(x) (x | 0x80081000)

enum 
{
 ALLOC_AREA = 0x1,
 MAP_AREA,
 FREE_AREA,
 GET_PAGES
} ioctl_codes;

#define IOCTL_ALLOC_AREA IOCTL_CODE(ALLOC_AREA)
#define IOCTL_MAP_AREA  IOCTL_CODE(MAP_AREA)
#define IOCTL_FREE_AREA  IOCTL_CODE(FREE_AREA)
#define IOCTL_GET_PAGES  IOCTL_CODE(GET_PAGES)

/////////////////////////////////////////////////////////////////////////////
//
// STRUCTURE: driver_info_t
//
// DESCRIPTION:
//              Structure contains the information about Driver
//
/////////////////////////////////////////////////////////////////////////////
typedef struct
{
        void* kAddr;
 areas_data_t Areas;
 // mmap
 unsigned int uiCurrentArea;
} driver_info_t;


/////////////////////////////////////////////////////////////////////////////
//
// STRUCTURE: ioctl_request_t
//
// DESCRIPTION:
//              Structure contains parameters of Driver request
//
/////////////////////////////////////////////////////////////////////////////
typedef struct
{
        // Code of command
        unsigned uCtlCode;

        // Number of bytes in input buffer
        unsigned uInLength;

        // Number of bytes in output buffer
        unsigned uOutLength;

        // Pointer to the exchange data buffer 
        void* pSysBuffer;

        // Number of bytes returned
        unsigned uReturnCount;
} ioctl_request_t;

#endif
